#!================================================================================================#
#TEMPLATE (cmag_sqlServer, 'SQL Server Integration Templates - cmag_SqlTRG.tpl'),FAMILY('ABC'),FAMILY('CW20')
#!================================================================================================#
#! File:    	cmag_SqlTRG.tpl
#! Copyright:
#! Author:     Ayo Ogundahunsi
#! Email:      ayo@dolasoft.com
#!
#!================================================================================================#
#SYSTEM
   #DECLARE (%TargetDatabaseName)
   #DECLARE (%DefaultFilename)
   #DECLARE (%DefaultScriptDirectory)

#!------------------------------------------------------------------------------------------------!
#!
#! Update History:
#!
#!-------------------------------------------------------------------------------------------#!
#UTILITY (sqlServer_AuditTrigger, 'SQL Code to generate Audit Trigger for Table(s)'), WIZARD
#!-------------------------------------------------------------------------------------------#!
#SHEET
   #PREPARE
      #DECLARE (%AuditTableLabel)   
      #DECLARE (%FieldCounter)   
      #DECLARE (%FieldList)   
      #DECLARE (%LineWrap) 
      #DECLARE (%TempFieldName)
      #DECLARE (%FieldCount)
      #DECLARE (%TotalColsPrinted)
      #DECLARE (%MaxColOnLine)
      #DECLARE (%ModificationMode)     
      #DECLARE (%ColumnChangedSize,30)
      #DECLARE (%TablesToAudit2), MULTI
      #DECLARE (%FieldsToExclude), MULTI
   #ENDPREPARE
   #TAB ('Audit Trigger Wizard - Select Table(s) to Auto-Include'),FINISH(0)
      #PROMPT ('Table Selection',FROM(%File, %FileDriver='MSSQL') ),%TablesToAudit1,INLINE,SELECTION('Table Selection')
      #BOXED ('Drop/Re-Create Audit Objects'), AT(,115)
         #PROMPT ('Drop/Re-Create Audit Table',CHECK),%DropCreate,DEFAULT(1),AT(10)
         #PROMPT ('Drop/Re-Create INSERT Trigger',CHECK),%DropCreateInsertT,DEFAULT(1),AT(10)
         #PROMPT ('Drop/Re-Create UPDATE Trigger',CHECK),%DropCreateUpdateT,DEFAULT(1),AT(10)
         #PROMPT ('Drop/Re-Create DELETE Trigger',CHECK),%DropCreateDeleteT,DEFAULT(1),AT(10)
      #ENDBOXED
   #ENDTAB
   #TAB ('Audit Trigger Wizard - Set Audit Options'),FINISH(1)
      #BOXED ('Audit Labels')
         #PROMPT ('Audit INSERTs',CHECK),%AuditInsert,DEFAULT(1),AT(10,15)
         #ENABLE (%AuditInsert=%true)
            #PROMPT ('Label:',@S20),%AfterInsertLabel,DEFAULT('INSERT'), PROMPTAT(130,15), AT(165,15)
         #ENDENABLE
         #DISPLAY ('')
         #PROMPT ('Audit pre-UPDATE Buffer',CHECK),%AuditBefore,DEFAULT(1),AT(10,30)
         #ENABLE (%AuditBefore=%true)
            #PROMPT ('Label:',@S20),%BeforeUpdateLabel,DEFAULT('UPDATE--BEFORE'), PROMPTAT(130,30), AT(165,30)
         #ENDENABLE
         #PROMPT ('Audit post-UPDATE Buffer',CHECK),%AuditAfter,DEFAULT(1),AT(10,45)
         #ENABLE (%AuditAfter=%true)
            #PROMPT ('Label:',@S20),%AfterUpdateLabel,DEFAULT('UPDATE-AFTER'), PROMPTAT(130,45), AT(165,45)
         #ENDENABLE
         #PROMPT ('Audit DELETEs',CHECK),%AuditDelete,DEFAULT(1),AT(10,60)
         #ENABLE (%AuditDelete=%true)
            #PROMPT ('Label:',@S20),%AfterDeleteLabel,DEFAULT('DELETE'), PROMPTAT(130,60), AT(165,60)
         #ENDENABLE
      #ENDBOXED
      #BOXED ('Audit Fields')
         #PROMPT ('Enable',CHECK),%EnableAuditIdentifierField,DEFAULT(1),AT(10,90)
         #ENABLE (%EnableAuditIdentifierField=%true)
            #PROMPT ('Audit Identifier:',@S20),%AuditIdentifier,REQ,DEFAULT('ActionSequence'), PROMPTAT(100,90), AT(165,90)
         #ENDENABLE
         #PROMPT ('Enable',CHECK),%EnableTimeStampField,DEFAULT(1),AT(10,105)
         #ENABLE (%EnableTimeStampField=%true)
            #PROMPT ('Timestamp:',@S20),%TimeStamp,REQ,DEFAULT('Audit_Date'), PROMPTAT(100,105), AT(165,105)
         #ENDENABLE
         #PROMPT ('Enable',CHECK),%EnableLoginIdentifierField,DEFAULT(1),AT(10,120)
         #ENABLE (%EnableLoginIdentifierField=%true)
            #PROMPT ('Login Identifier:',@S20),%LoginIdentifier,REQ,DEFAULT('Audit_User'), PROMPTAT(100,120), AT(165,120)
         #ENDENABLE
         #ENABLE (1=0)
            #PROMPT ('Enable',CHECK),%EnableChangedColField,DEFAULT(0),AT(10,135)
            #ENABLE (%EnableChangedColField=%true)
               #PROMPT ('Changed Column:',@S20),%ChangedColField,DEFAULT('ChangedColumn'), PROMPTAT(100,135), AT(165,135)
            #ENDENABLE
         #ENDENABLE
      #ENDBOXED
   #ENDTAB 
   #!
   #TAB ('Audit Trigger Wizard - Table(s) To Audit'),FINISH(1), WHERE(1=0)    #!>, WHERE(%AutoIncludeColumns=0)
      #DISPLAY ('With the Audit Trigger Wizard, you can generate a SQL script that will create Triggers on selected Tables'),AT(90,8,235,24)
      #BUTTON ('Generate Audit For '&%TablesToAudit1),FROM(%TablesToAudit1,%TablesToAudit1),INLINE
         #BOXED ('Audit Table')
            #PREPARE
               #SET (%AuditTableLabel,%TablePrefix2&%TablesToAudit1)
            #ENDPREPARE
            #PROMPT ('Prefix:',@S10),%TablePrefix2,DEFAULT('AUDIT_')
            #DISPLAY ('  Audit Table Name : '&%AuditTableLabel)
         #ENDBOXED
         #BOXED ('Column(s) to Audit')
            #BUTTON ('Columns To Audit (Table : '&%TablesToAudit1&')'),MULTI(%ColumnsToAudit,%ColumnToAudit),INLINE
               #PROMPT ('Column:',FIELD(%TablesToAudit1)),%ColumnToAudit
            #ENDBUTTON
         #ENDBOXED
      #ENDBUTTON
   #ENDTAB
   #prepare
      #SET (%DefaultFilename,'AUDIT_TRIGGERS')
      #SET (%DefaultScriptDirectory, 'C:\TEMP\')
   #endprepare
   #INSERT (%WizLocationTab)
#ENDSHEET



#SET (%LineWrap,'<13,10>')
#SET (%TotalColsPrinted,0)
#SET (%MaxColOnLine,8)

#CALL (%CreateTrigger)
#!
#!
#!
#!
#!--------------------------------------------------------------------------
#GROUP (%CreateTrigger,%CreateMethod='AUT0')
#!--------------------------------------------------------------------------
#! Generate SQL Code to create Audit Trigger
#!--------------------------------------------------------------------------
#DECLARE (%CurrentTable)
#DECLARE (%SQLScriptFile)
#IF (%GenerateSingleFile=%true)
   #SET (%SQLScriptFile,%SQLScriptDirectory&%SingleFilename&'.SQL')
   #CREATE (%SQLScriptFile)
#ENDIF
#!
#SET (%ColumnChangedSize,30)
-- Switch to appropriate database Context : %SQLDatabaseName
USE %SQLDatabaseName
GO

-- Confirm database context is correct, else terminate batch
IF DB_NAME() <> '%SQLDatabaseName'  BEGIN
   RAISERROR('Wrong Database Selected.',16,10)
   RETURN
END
GO

#IF (%CreateMethod='AUT0')
   #!Loop through all selected Tables
   #FOR (%TablesToAudit1)
      #FIX(%File,%TablesToAudit1)
      #SET (%CurrentTable,UPPER(%File ))
      #IF (%GenerateSingleFile=%false)
         #SET (%SQLScriptFile,%SQLScriptDirectory&'AUDIT_TRIGGER_'&%CurrentTable&'.SQL')
         #CREATE (%SQLScriptFile)
      #ENDIF
         #CALL (%CreateAuditTable,%CurrentTable,%CreateMethod)
      #IF (%GenerateSingleFile=%false)
         #CLOSE (%SQLScriptFile)
      #ENDIF
   #ENDFOR
#ELSE
#!
#ENDIF
#!
#IF (%GenerateSingleFile=%true)
   #CLOSE (%SQLScriptFile)
#ENDIF
#!--------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------------------------------#
#! ??
#!------------------------------------------------------------------------------------------------#
#GROUP (%CreateAuditTable,%TableToCode,%CreateMethod='AUT0')
#!--------------------------------------------------------------------------
#! Generate SQL Code to create Audit Table
#!--------------------------------------------------------------------------
#!DECLARE (%CurrentFile)
/************************************************************************************************************
dbo.%TableToCode
************************************************************************************************************/
-- Create a list of existing columns in %TableToCode/dbo.%TableToCode
SELECT COLUMN_NAME, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH, NUMERIC_PRECISION,NUMERIC_SCALE,TABLE_NAME INTO #TEMP_AUDIT 
FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = '%TableToCode'
GO


#SET (%FieldCount,0)
#FOR (%Field)
   #SET (%FieldCount,%FieldCount+1)
#ENDFOR

#IF (%DropCreate=%true)
-- Check for %TableToCode_AUDIT, if it exists, DROP it.
IF (OBJECT_ID('dbo.%TableToCode_AUDIT') IS NOT NULL) AND (OBJECTPROPERTY(OBJECT_ID('dbo.%TableToCode_AUDIT'),'IsTable')=1) BEGIN
   DROP TABLE dbo.%TableToCode_AUDIT
END
GO
#ENDIF

#IF (%DropCreateInsertT)
-- DROP the INSERT Trigger - %TableToCode_INSERT if it exists.
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[%TableToCode_INSERT]') and OBJECTPROPERTY(id, N'IsTrigger') = 1) BEGIN
   DROP TRIGGER [dbo].[%TableToCode_INSERT]
   #SET (%ModificationMode, 'CREATE')     
END
GO
#ENDIF

#IF (%DropCreateUpdateT)
-- DROP the UPDATE Trigger - %TableToCode_UPDATE if it exists.
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[%TableToCode_UPDATE]') and OBJECTPROPERTY(id, N'IsTrigger') = 1) BEGIN
   DROP TRIGGER [dbo].[%TableToCode_UPDATE]
   #SET (%ModificationMode, 'CREATE')     
END
GO
#ENDIF

#IF (%DropCreateDeleteT)
-- DROP the DELETE Trigger - %TableToCode_DELETE if it exists.
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[%TableToCode_DELETE]') and OBJECTPROPERTY(id, N'IsTrigger') = 1) BEGIN
   DROP TRIGGER [dbo].[%TableToCode_DELETE]
   #SET (%ModificationMode, 'CREATE')     
END
GO
#ENDIF

-- Check for %TableToCode_AUDIT, RE-CREATE it if it doesn't exist.
IF NOT ((OBJECT_ID('dbo.%TableToCode_AUDIT') IS NOT NULL) AND (OBJECTPROPERTY(OBJECT_ID('dbo.%TableToCode_AUDIT'),'IsTable')=1))
BEGIN
   -- Create the audit file from the structure of %TableToCode
   SELECT * INTO %TableToCode_AUDIT FROM %TableToCode
   WHERE 0=1
END
GO

#IF (%EnableAuditIdentifierField=%true)

-- Add '%AuditIdentifier' column to structure if it doesn't exist already
IF NOT EXISTS
  (SELECT COLUMN_NAME FROM #TEMP_AUDIT WHERE COLUMN_NAME = '%AuditIdentifier' AND TABLE_NAME = '%TableToCode')
BEGIN
  ALTER TABLE dbo.%TableToCode_AUDIT ADD %AuditIdentifier VARCHAR(20)    
END
GO
#ENDIF
#!
#!
#!
#IF (%EnableChangedColField=%true)

-- Add '%ChangedColField' column to structure if it doesn't exist already
IF NOT EXISTS
  (SELECT COLUMN_NAME FROM #TEMP_AUDIT WHERE COLUMN_NAME = '%ChangedColField' AND TABLE_NAME = '%TableToCode')
BEGIN
  ALTER TABLE dbo.%TableToCode_AUDIT ADD %ChangedColField VARCHAR(%ColumnChangedSize)    
END
GO
#ENDIF
#!
#!
#!
#IF (%EnableTimeStampField=%true)

-- Add '%TimeStamp' column to structure if it doesn't exist already
IF NOT EXISTS
  (SELECT COLUMN_NAME FROM #TEMP_AUDIT WHERE COLUMN_NAME = '%TimeStamp' AND TABLE_NAME = '%TableToCode')
BEGIN
  ALTER TABLE dbo.%TableToCode_AUDIT ADD %TimeStamp DATETIME   
END
GO
#ENDIF
#!
#!
#!
#IF (%EnableLoginIdentifierField=%true)

-- Add '%LoginIdentifier' column to structure if it doesn't exist already
IF NOT EXISTS
  (SELECT COLUMN_NAME FROM #TEMP_AUDIT WHERE COLUMN_NAME = '%LoginIdentifier' AND TABLE_NAME = '%TableToCode')
BEGIN
  ALTER TABLE dbo.%TableToCode_AUDIT ADD %LoginIdentifier NVARCHAR(256)   
END
GO
#ENDIF
GO

#!------------------------------------------------------------------------------------------------#
#! Code to generate an INSERT Trigger
#!------------------------------------------------------------------------------------------------#
#IF (%AuditInsert=%true)


/*-------------------------------------------------------------------------------------------------
INSERT TRIGGER ON %TableToCode
*/-------------------------------------------------------------------------------------------------
%ModificationMode TRIGGER %TableToCode_INSERT ON %TableToCode AFTER INSERT
AS
IF @@ROWCOUNT=0 RETURN        -- Test to see if any row(s) is/were really updated.
#INSERT (%SwitchONIdentityInsert)
#CALL (%CreateAuditTableFields,'inserted','INSERT_TRIGGER')
#INSERT (%SwitchOFFIdentityInsert)
GO
---------------------------------------------------------------------------------------------------
#ENDIF
#!------------------------------------------------------------------------------------------------#
#!
#!
#!
#!------------------------------------------------------------------------------------------------#
#! Code to generate UPDATE Triggers
#!------------------------------------------------------------------------------------------------#
#IF (%AuditBefore=%true or %AuditAfter=%true)


/*-------------------------------------------------------------------------------------------------
UPDATE TRIGGER ON %TableToCode
*/-------------------------------------------------------------------------------------------------
%ModificationMode TRIGGER %TableToCode_UPDATE ON %TableToCode AFTER UPDATE
AS
IF @@ROWCOUNT=0 RETURN        -- Test to see if any row(s) is/were really updated.
#INSERT (%SwitchONIdentityInsert)
#IF (%AuditBefore=%true)
   #CALL (%CreateAuditTableFields,'deleted','UPDATE_TRIGGER')
#ENDIF
#IF (%AuditAfter=%true)
   #CALL (%CreateAuditTableFields,'inserted','UPDATE_TRIGGER')
#ENDIF
#INSERT (%SwitchOFFIdentityInsert)
GO
---------------------------------------------------------------------------------------------------
#ENDIF
#!------------------------------------------------------------------------------------------------#
#!
#!
#!
#!------------------------------------------------------------------------------------------------#
#! Code to generate a DELETE Trigger
#!------------------------------------------------------------------------------------------------#
#IF (%AuditDelete=%true)


/*-------------------------------------------------------------------------------------------------
DELETE TRIGGER ON %TableToCode
*/-------------------------------------------------------------------------------------------------
%ModificationMode TRIGGER %TableToCode_DELETE ON %TableToCode AFTER DELETE
AS
IF @@ROWCOUNT=0 RETURN        -- Test to see if any row(s) is/were really updated.
#INSERT (%SwitchONIdentityInsert)
#CALL (%CreateAuditTableFields,'deleted','DELETE_TRIGGER')
#INSERT (%SwitchOFFIdentityInsert)
GO
---------------------------------------------------------------------------------------------------
#ENDIF
#!------------------------------------------------------------------------------------------------#

DROP TABLE #TEMP_AUDIT
GO
#!
#!
#!------------------------------------------------------------------------------------------------#
#! ??
#!------------------------------------------------------------------------------------------------#
#GROUP (%CreateAuditTableFields,STRING %UpdateActionString, STRING %DTriggerType)
#!--------------------------------------------------------------------------

INSERT %TableToCode_AUDIT 
   #SET ( %FieldCounter,0)
   #SET (%TotalColsPrinted, 0)
   #INSERT (%GetOriginalFields,'(',')')  
   #!
   #IF (%EnableAuditIdentifierField=%true)
      #SET (%FieldList,%FieldList& ','& %LineWrap &%AuditIdentifier)
   #ENDIF
   #IF (%EnableTimeStampField=%true)
      #SET (%FieldList,%FieldList& ','& %LineWrap &%TimeStamp)
   #ENDIF
   #IF (%EnableLoginIdentifierField=%true)
      #SET (%FieldList,%FieldList& ','& %LineWrap &%LoginIdentifier)
   #ENDIF
   #IF (%EnableAuditIdentifierField=%true)
      #SET (%FieldList,%FieldList& ' '&%LineWrap )
   #ENDIF
   #SET (%LineWrap,'<13,10>') #!Reset to wrap lines again
   #SET (%FieldList,%FieldList& ' '&%LineWrap &')')
%FieldList
#!
#CALL (%CreateSELECTForUpdateFields,%UpdateActionString,%DTriggerType)
#!--------------------------------------------------------------------------
#!
#!------------------------------------------------------------------------------------------------#
#! ??
#!------------------------------------------------------------------------------------------------#
#GROUP (%CreateSELECTForUpdateFields,%UpdateActionString,%DTriggerType)
#!--------------------------------------------------------------------------
SELECT 
   #SET ( %FieldCounter,0)
   #SET ( %FieldList,'')
   #INSERT (%GetOriginalFields,'','')  
   #IF (%EnableAuditIdentifierField=%true)
      #IF      (%UpdateActionString='deleted')
         #IF      (%DTriggerType='UPDATE_TRIGGER')
            #SET (%FieldList,%FieldList &','& %LineWrap&'<039>'&%BeforeUpdateLabel&'<039>')
         #ELSIF   (%DTriggerType='DELETE_TRIGGER')
            #SET (%FieldList,%FieldList &','& %LineWrap&'<039>'&%AfterDeleteLabel&'<039>')
         #ENDIF
      #ELSIF   (%UpdateActionString='inserted')
         #IF      (%DTriggerType='INSERT_TRIGGER')
            #SET (%FieldList,%FieldList &','& %LineWrap&'<039>'&%AfterInsertLabel&'<039>')
         #ELSIF   (%DTriggerType='UPDATE_TRIGGER')
            #SET (%FieldList,%FieldList &','& %LineWrap&'<039>'&%AfterUpdateLabel&'<039>')
         #ENDIF
      #ENDIF
   #ENDIF
   #IF (%EnableTimeStampField=%true)
      #SET (%FieldList,%FieldList& ','& %LineWrap &'GETDATE()')
   #ENDIF
   #IF (%EnableLoginIdentifierField=%true)
      #SET (%FieldList,%FieldList& ','& %LineWrap &'SUSER_SNAME()')
  #ENDIF
  #SET (%FieldList,%FieldList& ' FROM '&%UpdateActionString)
%FieldList

#!--------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------------------------------#
#! ??
#!------------------------------------------------------------------------------------------------#
#GROUP (%GetOriginalFields,%LeftBrace,%RightBrace)
#!--------------------------------------------------------------------------
#DECLARE (%TempFieldNameOld)
#DECLARE (%DateInGroup)
#DECLARE (%TimeInGroup)
   #SET (%TotalColsPrinted,0)
   #FOR (%Field) 
      #SET (%LineWrap,'')                       #!Reset to wrap lines NOT to wrap
      #SET (%TempFieldNameOld,%TempFieldName)
      #SET (%TempFieldName, SUB(%FieldStruct,1,INSTRING(' ',%FieldStruct,1,1)-1 ))
      #!
      #!
      #!-- Cycle conditions -----------------------------------------
      #IF (%TempFieldName = %AuditIdentifier OR %TempFieldName = %TimeStamp OR %TempFieldName = %LoginIdentifier)
         #CYCLE
      #ENDIF
      #IF (%FieldType = 'GROUP')
         #SET (%DateInGroup,%TempFieldNameOld&'_DATE')
         #SET (%TimeInGroup,%TempFieldNameOld&'_TIME')
         #CYCLE
      #ENDIF
      #IF (%TempFieldName=%DateInGroup OR %TempFieldName=%TimeInGroup)
         #CYCLE
      #ENDIF
      #IF (%FieldType = 'END')
         #SET (%DateInGroup,'')
         #SET (%TimeInGroup,'')
         #CYCLE
      #ENDIF
      #!-------------------------------------------------------------
      #!
      #SET ( %FieldCounter,%FieldCounter+1 )
      #IF (%TotalColsPrinted >= %MaxColOnLine)
         #SET (%TotalColsPrinted, 0)
         #SET (%LineWrap,'<13,10>')             #!Reset to wrap lines again
      #ENDIF
      #!
      #IF      (%FieldCounter=1)
         #SET (%LineWrap,'<13,10>')             #!Reset to wrap lines again
         #SET (%FieldList            ,%LeftBrace& %LineWrap& SUB(%FieldStruct,1,INSTRING(' ',%FieldStruct,1,1)-1 ))
      #ELSIF   (%FieldCounter>1)
         #SET (%FieldList,%FieldList &','& %LineWrap& SUB(%FieldStruct,1,INSTRING(' ',%FieldStruct,1,1)-1 ))
      #ENDIF
      #SET (%TotalColsPrinted, %TotalColsPrinted+1)
   #ENDFOR
#!--------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------------------------------#
#! ALTER Table in a batch
#!------------------------------------------------------------------------------------------------#
#GROUP (%AlterTableByBatch)
#!--------------------------------------------------------------------------
  ALTER TABLE dbo.%TableToCode_AUDIT ADD 
  ActionSequence VARCHAR(20),    
  -- Modify the structure to handle Timestamping, etc
  UpdateDate     DATETIME,
  UpdateUser     NVARCHAR(256),
  ColumnChanged  VARCHAR(%ColumnChangedSize)    
#!--------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------------------------------#
#! Switch on Identity insert
#!------------------------------------------------------------------------------------------------#
#GROUP (%SwitchONIdentityInsert)
#!--------------------------------------------------------------------------
/*------------------------------------------------------------------------------------------------------------
   This segment of code will test for the existence of an identity column in %TableToCode_AUDIT. 
   Since the %TableToCode_AUDIT is created with a 'SELECT INTO' clause using the table to be audited as a base, 
   then you have to find a way to switch off IDENTITY INSERTs before an update, else the Trigger will fail.
   You can determine whether a column is using IDENTITY by checking the status column in the syscolumns table 
   for bit mask 128. Another alternative is to query the INFORMATION_SCHEMA.TABLES view. for example:

      SELECT IDENT_SEED(TABLE_NAME) AS Seed, IDENT_INCR(TABLE_NAME) AS Increment, TABLE_NAME
      FROM INFORMATION_SCHEMA.TABLES  
      WHERE OBJECTPROPERTY(OBJECT_ID(TABLE_NAME),  'TableHasIdentity') = 1 
         AND   TABLE_TYPE = 'BASE TABLE'

*/------------------------------------------------------------------------------------------------------------
declare @HasIdentity int
SET @HasIdentity = 0

-- Check to see if %TableToCode_AUDIT has an identity column
IF EXISTS
(SELECT OBJECT_NAME(id) FROM syscolumns WHERE (status & 128) = 128 and OBJECT_NAME(id) = '%TableToCode_AUDIT')
BEGIN
   SET @HasIdentity = 1
END
--------------------------------------------------------------------------------------------------------------

-- Allow explicit values to be inserted into the identity column of %TableToCode_AUDIT
IF @HasIdentity = 1 BEGIN
   SET IDENTITY_INSERT %TableToCode_AUDIT ON   
END
#!--------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------------------------------#
#! Switch off Identity insert
#!------------------------------------------------------------------------------------------------#
#GROUP (%SwitchOFFIdentityInsert)
#!--------------------------------------------------------------------------

-- Switch off insertion of explicit values into %TableToCode_AUDIT
IF @HasIdentity = 1 BEGIN
   SET IDENTITY_INSERT %TableToCode_AUDIT OFF
END
#!--------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------------------------------#
#! Display Tab for Database name, File Location
#!------------------------------------------------------------------------------------------------#
#GROUP (%WizLocationTab)
#!------------------------------------------------------------------------------------------------#
	#TAB ('Audit Trigger Wizard - General'),FINISH(1),HLP('~DTSScriptWizard')
		#PROMPT ('Database Name',@S50),%SQLDatabaseName	,DEFAULT(%TargetDatabaseName)
		#PROMPT ('SQL Script Directory',@S100),%SQLScriptDirectory ,DEFAULT('C:\TEMP\')
   		#PROMPT ('Generate code to one file',CHECK),%GenerateSingleFile,DEFAULT(0)
		#ENABLE (%GenerateSingleFile=%true)
			#PROMPT ('Filename:',@S50),%SingleFilename ,DEFAULT('AUDIT_TRIGGER')
		#ENDENABLE
	#ENDTAB
#!------------------------------------------------------------------------------------------------#
