/* this creates the table necessary for the auto-increment test */
CREATE TABLE AUTOORA ( 
  ID         NUMBER (6)    NOT NULL, 
  ADDTIME    DATE, 
  THREADREF  CHAR (2), 
  CONSTRAINT PK_AUTOORA
  PRIMARY KEY ( ID ) ) ;
 /
 
/* this is the code to handle auto-incrementing on the autoora table */
CREATE OR REPLACE TRIGGER autoinc  
before insert on autoora  
for each row  
begin  
   :new.id := (select autoseq.nextval from dual);  
end;
/ 

/* creates the tables for the RI test: a parent file and a child file. The parent file
is populated with 100 rows extracted from all_objects */
create table parent as
  select object_id from all_objects
  where rownum <= 100;
/
ALTER TABLE CLARIONEX.PARENT
 ADD CONSTRAINT PK_PARENT
 PRIMARY KEY (OBJECT_ID);
 / 
create table child
(parent_id number,
childnum number,
CONSTRAINT PK_CHILD
 PRIMARY KEY (PARENT_ID, CHILDNUM);
 /
/* this constraint is what manages the deletion of child records when the parent is removed
this constraint is disabled for the test of the Clarion-managed RI*/
alter table child
 ADD CONSTRAINT FK_child_parent
 FOREIGN KEY (PARENT_ID)
 REFERENCES PARENT (OBJECT_ID)
 ON DELETE CASCADE;
 /
 /* this anonymous code block inserts records into the child table: 50 rows per parent */
declare
i number; 
cursor parcurs is select object_id from parent;
begin
for pc in parcurs loop
  for i in 1..50 loop
     insert into child values (pc.object_id,i);
  end loop;
end loop;
commit;   
end;  	 
/